(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["normalizer"] = factory();
	else
		root["normalizer"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


function tf(obj) {
  var arr = [];
  tfr(arr, obj, null);
  return arr;
}

function tfr(arr, obj, level) {
  Object.keys(obj).forEach(function (e) {
    arr.push({ 'key': e, 'parent': level });
    if (Object.prototype.toString.call(obj[e]) === '[object Object]') {
      tfr(arr, obj[e], e);
    }
  });
}

function treeTolist(arr, data) {
  var KEY = 0;
  var VALUE = 1;

  var arrObj = [];
  for (var key in data) {
    arrObj.push([key, data[key]]);
  }

  arrObj.forEach(function (e) {
    if (Object.prototype.toString.call(e[VALUE]) === '[object Object]') {
      treeTolist(arr, e[VALUE]);
    } else {
      arr.push([e[KEY], e[VALUE]]);
    }
  });
  return arr;
}

/**
*  Convert a object tree to a array of leaf
*  @param input - Object data
*  @returns output  - leaf array [key: value]
*/
function destructObj(input) {
  var arr = [];
  var output = treeTolist(arr, input);
  return output;
}

/**
*  Convert a array of leaf to a object tree
*  corresponding the specific schema.
*  @param leaf - leaf array
*  @param schema - specific schema
*  @param parent - root parent
*  @returns output  - Object with the structure of schema
*/
function constructObj(data, schema, parent) {
  var KEY = 0;
  var VALUE = 1;
  var node = {};
  schema.filter(function (s) {
    return s.parent === parent;
  }).forEach(function (s) {
    var a = [];
    if (data.find(function (e) {
      return e[KEY] === s.key;
    })) {
      a = data.find(function (e) {
        return e[KEY] === s.key;
      });
    }
    node[s.key] = typeof a[VALUE] !== 'undefined' ? a[VALUE] : constructObj(data, schema, s.key);
  });
  return node;
}

function normalizer(input, schema) {
  var leaf = destructObj(input);
  var tfschema = tf(schema);
  var output = constructObj(leaf, tfschema, null);
  return output;
}

module.exports = normalizer;

/***/ })
/******/ ]);
});